#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>

char *replace(char *before, char *oldsub, char *newsub);

int main(int argc, char **argv){ 

    char *filename = argv[1];
    FILE *fp = fopen(filename, "r");

    if (fp == NULL)
    {
        printf("Error: could not open file %s", filename);
        return 1;
    }

    char *new_str2;
    char new_str[1000];

    char ch;
    char temp[1000];
    while ((ch = (char)fgetc(fp)) != EOF){
        strncat(temp, &ch,1);
    }

    int fd1[2]; // Used to store two ends of first pipe
    int fd2[2]; // Used to store two ends of second pipe

    if (pipe(fd1) == -1) {
        fprintf(stderr, "Pipe Failed");
        return 1;
    }
    if (pipe(fd2) == -1) {
        fprintf(stderr, "Pipe Failed");
        return 1;
    }

    pid_t p;
    p = fork();

    if (p < 0) {
        fprintf(stderr, "fork Failed");
        return 1;
    }
 
    else if (p > 0) {
        char final_str[100];
 
        close(fd1[0]); // Close reading end of first pipe
 
        // Write input string and close writing end of first
        // pipe.
        write(fd1[1], temp, strlen(temp) + 1);
        close(fd1[1]);
 
        // Wait for child to send a string
        wait(NULL);
 
        close(fd2[1]); // Close writing end of second pipe
 
        // Read string from child, print it and close
        // reading end.
        read(fd2[0], final_str, 1000);
        printf("%s\n", final_str);
        close(fd2[0]);
    }
        
    // child process
    else {
        close(fd1[1]); // Close writing end of first pipe
 
        // Read a string using first pipe
        
        read(fd1[0], new_str, 1000);
        
        // Switch the words in the string
        
        //new_str2 = replace(new_str, "evil", "good"); //example usage - working correctly. its missing a way to store the cypher and call this function as many times as needed


        /*char *cyphername = argv[2];
        FILE *fp2 = fopen(cyphername, "r");
        char word1[10];
        char word2[10];
        bool flag = false;
        while ((ch = (char)fgetc(fp2)) != EOF){
            if(ch == ' ') {
                flag = true;
                printf("%s", word2);
                strcpy(word2, "");
            }
            if(ch == '\n') {
                flag = false;
                new_str2 = replace(new_str, word1, word2);
                strcpy(word1, "");

            }
            if (!flag) strncat(word1, &ch,1);
            if (flag) strncat(word2, &ch, 1);
            }
            
        }

        */
        
 
        // Close both reading ends
        close(fd1[0]);
        close(fd2[0]);
 
        // Write new string and close writing end
        write(fd2[1], new_str2, strlen(new_str2) + 1);
        close(fd2[1]);
 
        exit(0);
    }
}


char *replace(char *before, char *oldsub, char *newsub)
{
  // get the lengths of the before string, old substring and new substring
  int old_length = strlen(oldsub);
  int new_length = strlen(newsub);
  int before_length = strlen(before);
  
  // stores pointer to the dynamically allocated after string
  char *after;
  
  // if the length of the old substring is the same as the new substring, 
  // we can allocate space for the after string without doing any analysis 
  // of the before string beforehand
  if (old_length == new_length)
  {
    // allocate the same amount of space for the after string as the before
    // string (the +1 is for the null terminator)
    after = malloc((before_length + 1) * sizeof(char));
  }
  // otherwise we need to figure out how many times does the old substring 
  // occur in the before string, and use that information to allocate enough
  // space for the after string
  else
  {
    // keeps track of occurrences of the old substring in the before string
    int occurrences = 0;
    
    // use i as the current position in the before string and loop through 
    // the string until we reach the end of the string
    int i = 0;
    while (i < before_length)
    {
      // if the first occurrence of the old substring in the before string 
      // from index i onwards occurs at index i, then we have found an 
      // occurrence of the substring at index i
      if (strstr(&before[i], oldsub) == &before[i])
      {
        // we increment the number of occurrences, and increment i by the 
        // length of the old substring to skip over the old substring characters
        occurrences++;
        i += old_length;
      }
      // otherwise if we did not find an occurrence, increment i by 1 to check
      // for an occurrence at the next index
      else i++;
    }
    
    // calculate the difference between the new and old substring lengths
    int sub_diff = new_length - old_length;

    // use the before string's length as a starting point for the after 
    // string's length
    int after_length = before_length;
    
    // and now adjust the after string's length by the number of occurrences 
    // in the before string multipled by the difference in length between 
    // the new substring and the old substring (and keep in mind if the new 
    // substring is less length than the old substring, it will be negative 
    // and as appropriate after_length will be less than before_length)
    after_length += occurrences * sub_diff;
    
    // allocate space for the after string, accounting for the null terminator
    after = malloc((after_length + 1) * sizeof(char));
  }
  
  // i will keep track of our current index in the before string
  int i = 0;

  // j will keep track of our current index in the after string that we will 
  // now build
  int j = 0;
  
  // again we loop through the before string, just as above, but now we 
  // will build the after string as we do so
  while (i < strlen(before))
  {
    // if the first occurrence of the old substring in the before string 
    // from index i onwards occurs at index i, then we have found an 
    // occurrence of the substring at index i 
    if (strstr(&before[i], oldsub) == &before[i])
    {
      // we now copy into the after string AT INDEX J the new substring
      strcpy(&after[j], newsub);

      // we skip over old substring's amount of characters in the before string
      i += old_length;

      // but we add the new substring's amount of characters to j, because the 
      // length of the old and new substring's may be different... j may be less
      // or more than i, but we'll use it to keep track of where we are writing 
      // next into the after string
      j += new_length;
    }
    // if we did not find an occurrence of the old substring at index i in the 
    // before string, we copy the next character from the before string into the
    // after string (using the respective variables), and we increment the 
    // the indexes by 1 to move onto the next element in each array
    else
    {
      after[j] = before[i];
      i++;
      j++;
    }
  }
  
  // put a null terminator at the end of the after string
  after[j] = '\0';
  
  // return a pointer to the after string
  return after;
}
